dofile_once("data/scripts/lib/utilities.lua")

local carrion = GetUpdatedEntityID()

local x, y = EntityGetTransform(carrion)

local velocity_component = EntityGetFirstComponentIncludingDisabled(carrion, "VelocityComponent")
vel_x, vel_y = ComponentGetValue2( velocity_component, "mVelocity" )
local direction_x, direction_y = vec_normalize(vel_x, vel_y)


local limb_count = 10

local limb_reach = 500

function rotate_degrees(x, y, degrees)
	return rotate_radians(x, y, math.rad(degrees))
end

function rotate_radians(x, y, radians)
	local ca = math.cos(radians)
	local sa = math.sin(radians)
	local out_x = ca * x - sa * y
	local out_y = sa * x + ca * y
	return out_x, out_y
end


local count_leg = tonumber(GlobalsGetValue("leg_count", "1"))

if(count_leg > limb_count)then
    count_leg = 1
end
GlobalsSetValue("leg_count", tostring(count_leg + 1))

SetRandomSeed(x, y)

local limb_positions = {}

-- if(shoot_button_down == true)then
    for i = 1, limb_count do
        local rad_offset = Random(-120, 120)
        local  cast_direction = {x = 0, y = 0}
        cast_direction.x, cast_direction.y = rotate_degrees(direction_x, direction_y, rad_offset)

        local point = {x = 0, y = 0, hit = false}
        point.hit, point.x, point.y = RaytraceSurfaces( x + (cast_direction.x * 19), y + (cast_direction.y * 19), x + (cast_direction.x * limb_reach), y + (cast_direction.y * limb_reach) )


        if(point.hit)then


            point.x, point.y = point.x + (cast_direction.x * 10), point.y + (cast_direction.y * 10)

            table.insert(limb_positions, {x = point.x, y = point.y})
        end
    end

    

    local variable_storage = EntityGetComponent(carrion, "VariableStorageComponent")

    for i=1, limb_count do
        limb = {x = 0, y = 0}
        if(limb_positions[i] ~= nil)then
            limb.x, limb.y = limb_positions[i].x, limb_positions[i].y
            --GamePrint(i)
        end
        local limb_storage_found = false
        if(variable_storage ~= nil)then
            for o, v in pairs(variable_storage)do
                local name = ComponentGetValue2(v, "name")

                if(name == "limb_position2_"..tostring(i))then
                    if(i == count_leg)then
                    -- GamePrint("x: "..limb.x..", y: "..limb.y)
                        ComponentSetValue2(v, "value_string", tostring(limb.x))
                        ComponentSetValue2(v, "value_int", limb.y)
                        limb_storage_found = true
                    end
                end
            end
        end
        if(limb_storage_found ~= true)then
            if(i == count_leg)then
                EntityAddComponent(carrion, "VariableStorageComponent", {
                    name="limb_position2_"..tostring(i),
                    value_string=tostring(limb.x),
                    value_int=limb.y,
                })         
            end
        end
    end
-- end