CHEST_LEVEL = 5
dofile_once("data/scripts/director_helpers.lua")
dofile_once("data/scripts/biome_scripts.lua")

RegisterSpawnFunction(0xffffeedd, "init")
RegisterSpawnFunction(0xffcc1272, "spawn_eye")
RegisterSpawnFunction(0xffc322b8, "spawn_meatball")
RegisterSpawnFunction(0xffdd08b8, "spawn_flesh_wall")
RegisterSpawnFunction(0xff08dd2c, "spawn_flesh_boss")
RegisterSpawnFunction(0xff086fdd, "spawn_flesh_boss_mouth")
RegisterSpawnFunction(0xffff4646, "spawn_flesh_boss_heart")
RegisterSpawnFunction(0xff771717, "spawn_mouth_right")
RegisterSpawnFunction(0xffee1515, "spawn_mouth_left")
RegisterSpawnFunction(0xffbfb6f2, "spawn_ground_flesh")
RegisterSpawnFunction(0xffee5e1d, "spawn_cancer")
RegisterSpawnFunction(0xffaa4112, "spawn_cancer_ceiling")
RegisterSpawnFunction(0xffa14e1f, "spawn_geyser")
RegisterSpawnFunction(0xffdf8a5a, "spawn_geyser_small")
RegisterSpawnFunction(0xfff21717, "spawn_lavafall")
RegisterSpawnFunction(0xff139472, "spawn_gasgeyser")
RegisterSpawnFunction(0xff80FF5A, "spawn_vines")
RegisterSpawnFunction(0xfffff700, "spawn_wand_altar")

g_small_enemies =
{
	total_prob = 0,
	{
		prob   		= 1,
		min_count	= 0,
		max_count	= 0,    
		entity 	= ""
	},
	{
		prob   		= 2,
		min_count	= 1,
		max_count	= 1,    
		entity 	= "data/entities/animals/flesh_spider.xml"
	},
	{
		prob   		= 1,
		min_count	= 1,
		max_count	= 1,    
		entity 	= "data/entities/animals/vomiter.xml"
	},
	{
		prob   		= 0.5,
		min_count	= 1,
		max_count	= 1,    
		entity 	= "data/entities/animals/brain.xml"
	},
}

g_big_enemies =
{
	total_prob = 0,
	{
		prob   		= 1,
		min_count	= 0,
		max_count	= 0,    
		entity 	= ""
	},
	{
		prob   		= 2,
		min_count	= 1,
		max_count	= 1,    
		entity 	= "data/entities/animals/flesh_spider.xml"
	},
	{
		prob   		= 1,
		min_count	= 1,
		max_count	= 1,    
		entity 	= "data/entities/animals/vomiter.xml"
	},
	{
		prob   		= 0.5,
		min_count	= 1,
		max_count	= 1,    
		entity 	= "data/entities/animals/brain.xml"
	},
}

if ModIsEnabled("new_enemies") then
	table.insert(g_big_enemies, {
		prob   		= 1,
		min_count	= 1,
		max_count	= 1,    
		entity 	= "data/entities/animals/flesh_monster.xml"
	})
	table.insert(g_small_enemies, {
		prob   		= 1,
		min_count	= 1,
		max_count	= 1,    
		entity 	= "data/entities/animals/flesh_monster.xml"
	})
	table.insert(g_big_enemies, {
		prob   		= 0.5,
		min_count	= 1,
		max_count	= 1,    
		entity 	= "data/entities/animals/menace.xml"
	})
	table.insert(g_small_enemies, {
		prob   		= 0.5,
		min_count	= 1,
		max_count	= 1,    
		entity 	= "data/entities/animals/menace.xml"
	})
end

g_wands = {
	total_prob = 0,
	{
		prob = 1,
		file = "data/entities/items/wand_level_03.xml",
	},
	{
		prob = 0.5,
		file = "data/entities/items/wand_unshuffle_03.xml",
	},
	{
		prob = 1,
		file = "data/entities/items/wand_unshuffle_02.xml",
	},
	{
		prob = 1,
		file = "data/entities/items/wand_unshuffle_01.xml",
	},
	{
		prob = 0.5,
		file = "data/entities/items/wand_unshuffle_04.xml",
	}
}

g_pixel_scene_01 =
{
	total_prob = 0,
	{
		prob   			= 1,
		material_file 	= "mods/VolcanoBiome/files/pixel_scenes/horizontal_1.png",
		visual_file		= "",
		background_file	= "",
		is_unique		= 0,
	},
	{
		prob   			= 1,
		material_file 	= "mods/VolcanoBiome/files/pixel_scenes/horizontal_2.png",
		visual_file		= "",
		background_file	= "",
		is_unique		= 0,
	},
	{
		prob   			= 1,
		material_file 	= "mods/VolcanoBiome/files/pixel_scenes/horizontal_3.png",
		visual_file		= "",
		background_file	= "",
		is_unique		= 0,
	},
	{
		prob   			= 1,
		material_file 	= "mods/VolcanoBiome/files/pixel_scenes/horizontal_4.png",
		visual_file		= "",
		background_file	= "",
		is_unique		= 0,
	},
}

g_pixel_scene_02 =
{
	total_prob = 0,
	{
		prob   			= 1,
		material_file 	= "mods/VolcanoBiome/files/pixel_scenes/vertical_1.png",
		visual_file		= "mods/VolcanoBiome/files/pixel_scenes/vertical_1_visual.png",
		background_file	= "",
		is_unique		= 0,
	},
	{
		prob   			= 1,
		material_file 	= "mods/VolcanoBiome/files/pixel_scenes/vertical_2.png",
		visual_file		= "mods/VolcanoBiome/files/pixel_scenes/vertical_2_visual.png",
		background_file	= "",
		is_unique		= 0,
	},
	{
		prob   			= 1,
		material_file 	= "mods/VolcanoBiome/files/pixel_scenes/vertical_3.png",
		visual_file		= "",
		background_file	= "",
		is_unique		= 0,
	},
}

g_vines =
{
	total_prob = 0,
	{
		prob   		= 1.5,
		min_count	= 1,
		max_count	= 1,    
		entity 	= ""
	},
	{
		prob   		= 0.4,
		min_count	= 1,
		max_count	= 1,    
		entity 	= "mods/flesh_biome/files/entities/verlet/verlet_vine.xml"
	},
	{
		prob   		= 0.3,
		min_count	= 1,
		max_count	= 1,    
		entity 	= "mods/flesh_biome/files/entities/verlet/verlet_vine_long.xml"
	},
	{
		prob   		= 0.5,
		min_count	= 1,
		max_count	= 1,    
		entity 	= "mods/flesh_biome/files/entities/verlet/verlet_vine_short.xml"
	},
	{
		prob   		= 0.5,
		min_count	= 1,
		max_count	= 1,    
		entity 	= "mods/flesh_biome/files/entities/verlet/verlet_vine_shorter.xml"
	},
	{
		prob   		= 0.4,
		min_count	= 1,
		max_count	= 1,    
		entity 	= "mods/flesh_biome/files/entities/verlet/verlet_vine2.xml"
	},
	{
		prob   		= 0.3,
		min_count	= 1,
		max_count	= 1,    
		entity 	= "mods/flesh_biome/files/entities/verlet/verlet_vine_long2.xml"
	},
	{
		prob   		= 0.5,
		min_count	= 1,
		max_count	= 1,    
		entity 	= "mods/flesh_biome/files/entities/verlet/verlet_vine_short2.xml"
	},
	{
		prob   		= 0.5,
		min_count	= 1,
		max_count	= 1,    
		entity 	= "mods/flesh_biome/files/entities/verlet/verlet_vine_shorter2.xml"
	},
}

function init( x, y, w, h )
	LoadPixelScene( "mods/flesh_biome/files/biome_impl/flesh_boss.png", "", x - 100, y - 100, "", true )
	LoadPixelScene( "mods/flesh_biome/files/biome_impl/flesh_boss_empty.png", "", x, y - 50, "mods/flesh_biome/files/biome_impl/flesh_boss_background.png", true )
	-- LoadBackgroundSprite( "mods/flesh_biome/files/biome_impl/flesh_boss_background.png", x, y -50, 40, false )
end

function spawn_vines(x, y)
	spawn(g_vines,x+5,y+5)
	-- chance for an extra spawn for denser vineage
	if ProceduralRandomf(x, y) < 0.5 then
		spawn(g_vines,x,y+5)
	end
end

function spawn_small_enemies(x, y, w, h, is_open_path)
	SetRandomSeed(GameGetFrameNum(), x + y)
	if Random(100) <= 75 then
		local entity_data = random_from_table(g_small_enemies, x, y)
		entity_load_camera_bound(entity_data, x, y, 0, 0)
	end
end

function spawn_big_enemies(x, y, w, h, is_open_path)
	SetRandomSeed(GameGetFrameNum(), x + y)
	if Random(100) <= 75 then
		local entity_data = random_from_table(g_big_enemies, x, y)
		entity_load_camera_bound(entity_data, x, y, 0, 0)
	end
end

function spawn_items(x, y)
  LoadPixelScene("data/biome_impl/wand_altar.png", "data/biome_impl/wand_altar_visual.png", x-5, y-10, "", true)
end

function spawn_wands(x, y)
	EntityLoad(random_from_table(g_wands, GameGetFrameNum(), x + y).file, x, y)
end

function spawn_wand_altar(x, y)
  LoadPixelScene("data/biome_impl/wand_altar.png", "data/biome_impl/wand_altar_visual.png", x-5, y-12, "", true)
end

function spawn_wand_altar_low_chance(x, y)
  SetRandomSeed(GameGetFrameNum(), x + y)
  if Random(100) <= 30 then
    LoadPixelScene("data/biome_impl/wand_altar.png", "data/biome_impl/wand_altar_visual.png", x-5, y-10, "", true)
  end
end

function spawn_ballpuzzle(x, y)
	SetRandomSeed(GameGetFrameNum(), x + y)
	if Random(100) <= 50 then
		EntityLoad("mods/VolcanoBiome/files/entities/ballgame/ball.xml", x, y)
		EntityLoad("mods/VolcanoBiome/files/entities/ballgame/goal.xml", x + 152, y + 20)
	end
end

function spawn_props(x, y)
  EntityLoad("data/entities/props/physics_seamine.xml", x, y)
end

function spawn_heart(x, y)
	SetRandomSeed(GameGetFrameNum(), x + y)
  if Random(100) <= 25 then
		EntityLoad("data/entities/items/pickup/heart.xml", x+4, y+3)
	end
end

function spawn_potion_altar(x, y)
  LoadPixelScene( "data/biome_impl/potion_altar.png", "data/biome_impl/potion_altar_visual.png", x-5, y-15, "", true )
end

function spawn_potions(x, y)
  EntityLoad("data/entities/items/pickup/potion.xml", x, y-2)
end

-- horizontal
function load_pixel_scene(x, y)
	--LoadPixelScene("mods/VolcanoBiome/files/pixel_scene_horizontal_3.png", "", x, y, "", false, false)
	--GameCreateSpriteForXFrames("data/debug/circle_16.png", x, y, true, 0, 0, 1000000)
	-- local temp = LoadPixelScene
	-- LoadPixelScene = function(a, b, x, y, c)
	-- 	temp(a, b, x, y, c, true, false)
	-- end
	load_random_pixel_scene(g_pixel_scene_01, x, y)
	-- LoadPixelScene = temp
end

-- vertical
function load_pixel_scene2(x, y)
	--LoadPixelScene("mods/VolcanoBiome/files/pixel_scene_vertical_3.png", "", x, y, "", false, false)
	--GameCreateSpriteForXFrames("data/debug/circle_16.png", x, y, true, 0, 0, 1000000)
	-- local temp = LoadPixelScene
	-- LoadPixelScene = function(a, b, x, y, c)
	-- 	temp(a, b, x, y, c, true, false)
	-- end
	load_random_pixel_scene(g_pixel_scene_02, x, y)
	-- LoadPixelScene = temp
end

function spawn_gasgeyser(x, y)
	EntityLoad("mods/flesh_biome/files/entities/geyser/gasgeyser.xml", x + 5, y + 15)
end

function spawn_geyser_small(x, y)
	EntityLoad("mods/flesh_biome/files/entities/geyser/lavageyser_weak.xml", x + 5, y + 15)
end

function spawn_geyser(x, y)
	EntityLoad("mods/flesh_biome/files/entities/geyser/lavageyser.xml", x + 5, y + 15)
end

function spawn_meatball(x, y)
	EntityLoad("mods/flesh_biome/files/entities/meatball/meatball.xml", x + 5, y + 15)
end

function spawn_cancer(x, y)
	EntityLoad("data/entities/animals/cancer.xml", x, y + 6)
end

function spawn_cancer_ceiling(x, y)
	EntityLoad("data/entities/animals/cancer_ceiling.xml", x, y + 6)
end

function spawn_ground_flesh(x, y)
	EntityLoad("data/entities/animals/ground_flesh_loader.xml", x, y)
end

function spawn_mouth_right(x, y)
	EntityLoad("data/entities/animals/mouth_right.xml", x + 4, y)
end

function spawn_mouth_left(x, y)
	EntityLoad("data/entities/animals/mouth_left.xml", x + 9, y)
end

function spawn_flesh_boss(x, y)
	EntityLoad("data/entities/animals/flesh_boss.xml", x, y)
end

function spawn_flesh_boss_mouth(x, y)
	EntityLoad("data/entities/animals/flesh_boss_mouth.xml", x, y)
end

function spawn_flesh_boss_heart(x, y)
	EntityLoad("data/entities/animals/flesh_boss_heart.xml", x, y)
	LoadBackgroundSprite( "mods/flesh_biome/files/entities/flesh_boss/flesh_boss_heart_background.xml", x, y, 40.0, false )
end

function spawn_flesh_wall(x, y)
	EntityLoad("mods/flesh_biome/files/entities/flesh_wall/sea_rock_vertical.xml", x, y)
end

function spawn_eye(x, y)

	SetRandomSeed( GameGetFrameNum(), x + y )
	local eyes = { "mods/flesh_biome/files/entities/eye/eye.xml","mods/flesh_biome/files/entities/eye/eye2.xml", "mods/flesh_biome/files/entities/eye/eye3.xml" }
	local random_index = Random(1, #eyes)
	local eye = eyes[random_index]
	
	EntityLoad(eye, x, y)
end

function spawn_lavafall(x, y)
	-- Origin x, y is at the bottom, shoots a ray to the top to find the position it should spew out of
	EntityLoad("mods/flesh_biome/files/entities/lavafall/lavafall.xml", x + 5, y + 13)
end

function spawn_props2() end
function spawn_props3() end
function spawn_lamp() end
function spawn_unique_enemy() end
function spawn_unique_enemy2() end
function spawn_unique_enemy3() end
function spawn_ghostlamp() end
function spawn_candles() end
function spawn_apparition() end
function spawn_portal() end
function spawn_end_portal() end
function spawn_orb() end
function spawn_perk() end
function spawn_all_perks() end
function spawn_wand_trap() end
function spawn_wand_trap_ignite_a() end
function spawn_wand_trap_ignite_b() end
function spawn_wand_trap_electricity_source() end
function spawn_wand_trap_electricity() end
function spawn_moon() end
