dofile_once("data/scripts/lib/utilities.lua")
dofile_once( "mods/flesh_biome/files/scripts/invisibility_check.lua" )

local range = 150
local projectile_velocity = 20
local scatter = 0

local entity_id = GetUpdatedEntityID()
local pos_x, pos_y = EntityGetFirstHitboxCenter( entity_id )

-- locate nearest enemy
local enemy, enemy_x, enemy_y
local min_dist = 9999
for _,id in pairs(EntityGetInRadiusWithTag(pos_x, pos_y, range, "mortal")) do
	-- is target a valid enemy
	if ( entity_id ~= id ) and ( EntityGetParent(id) ~= entity_id ) and ( EntityGetFirstComponent(id, "GenomeDataComponent") ~= nil ) and ( EntityGetFirstComponent(id, "GenomeDataComponent") > 0 ) and ( EntityGetHerdRelation(entity_id, id) < 40 ) and ( is_invisible(id) == false ) then
		local x, y = EntityGetFirstHitboxCenter( id )
		local dist = get_distance(pos_x, pos_y, x, y)
		if dist < min_dist then
			min_dist = dist
			enemy = id
			enemy_x = x
			enemy_y = y
		end
	end
end

-- check los
local can_shoot = false
if enemy then can_shoot = not RaytraceSurfacesAndLiquiform(pos_x, pos_y, enemy_x, enemy_y) end

-- hand/shooting state & animation control
-- edit_component2( entity_id, "SpriteComponent", function(comp,vars)
	-- -- if enemy is not visible then open hand
	-- local hand_open = ComponentGetValue2(comp, "rect_animation") == "stand"
	-- if not can_shoot then
		-- if not hand_open then
			-- ComponentSetValue2( comp, "rect_animation", "stand")
			-- --EntitySetComponentsWithTagEnabled( entity_id, "enabled_when_attacking", false )
		-- end
		-- return
	-- end

	-- -- prepare to shoot
	-- if hand_open then
		-- ComponentSetValue2( comp, "rect_animation", "attack")
		-- --EntitySetComponentsWithTagEnabled( entity_id, "enabled_when_attacking", true )
		-- can_shoot = false
		-- return
	-- end
-- end)

if not can_shoot then return end

-- direction
local vel_x, vel_y = vec_sub(enemy_x, enemy_y, pos_x, pos_y)
vel_x,vel_y = vec_normalize(vel_x, vel_y)

-- offset to shoot direction to avoid colliding with hand
-- pos_x = pos_x + vel_x * 8
-- pos_y = pos_y + vel_y * 8

-- scatter
SetRandomSeed(pos_x + GameGetFrameNum(), pos_y)
vel_x,vel_y = vec_rotate(vel_x,vel_y, rand(-scatter, scatter))

-- apply velocity & shoot
vel_x,vel_y = vec_mult(vel_x,vel_y, projectile_velocity)

local distance = get_distance(pos_x, pos_y, enemy_x, enemy_y)

if distance < range then
	--animation
	local sprite_component = EntityGetFirstComponent(entity_id, "SpriteComponent")
	local animation = ComponentGetValue2( sprite_component, "rect_animation")

	ComponentSetValue2(sprite_component, "rect_animation", "open")
	ComponentSetValue2(sprite_component, "next_rect_animation", "stand")

	--attack
	local projectile_id = shoot_projectile( entity_id, "mods/flesh_biome/files/projectiles/flesh_stalker_shot.xml", pos_x + 2 , pos_y + 11, vel_x, vel_y)


	-- --set speed depending on distance of target from entity
	-- local vel_comp = EntityGetFirstComponentIncludingDisabled(projectile_id, "VelocityComponent")
	-- -- local vx, vy = ComponentGetValue2(vel_comp, "mVelocity")
	-- -- vx, vy = vec_normalize(vx, vy)
	-- -- ComponentSetValue2(vel_comp, "mVelocity", vx * distance, vy * distance )
	-- -- ComponentSetValue2(vel_comp, "mVelocity", vx * distance, vy * distance )

	-- -- set air friction depending on distance
	-- local air_friction = ComponentGetValue2(vel_comp, "air_friction")
	-- ComponentSetValue2(vel_comp, "air_friction", -0.05 * distance)
end
