dofile_once( "data/scripts/lib/utilities.lua" )

local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform( entity_id )

local prey = EntityGetInRadiusWithTag(x, y, 5, "mortal")
local prey_id = prey[1]
local prey_x, prey_y = EntityGetTransform( entity_id )

if #prey > 0 and not EntityHasTag(prey_id, "helpless_animal") then

	if Random(100) <= 100 then
	
		local lua_comps = EntityGetComponent(entity_id, "LuaComponent") or {}
		
		for i, comp in ipairs(lua_comps) do
		
			if ComponentGetValue2(comp, "script_source_file") ~= "mods/flesh_biome/files/scripts/latcher.lua" then

				EntitySetTransform(entity_id, prey_x, prey_y)

				EntityAddComponent(entity_id, "LuaComponent", {
					script_source_file="mods/flesh_biome/files/scripts/latcher.lua",
					execute_every_n_frame=1,
					execute_on_added=1,
				})
				
			end
			
		end
		
	end
	
end

local player = EntityGetInRadiusWithTag(x, y, 50, "player_unit")

local player_id = player[1]

if #player > 0 then

local tag = "fish_attractor"
				
	if not EntityHasTag(player_id, tag) then
			
		EntityAddTag( player_id, tag )
		
		EntityAddComponent(player_id, "LuaComponent", {
			script_source_file="mods/flesh_biome/files/scripts/fish_attractor_checker.lua",
			execute_every_n_frame=20,
			execute_on_added=0,
		}) 
				
	end
end

ComponentSetValue(GetUpdatedComponentID(), "execute_every_n_frame", 30 + Random(180))