dofile_once("data/scripts/lib/utilities.lua")

local max_distance = 1000
local field_of_view = 100

local targetX, targetY = EntityGetTransform(EntityGetWithTag("player_unit")[1])
local entity_id = GetUpdatedEntityID()
local x, y, rot = EntityGetTransform(entity_id)

function map(s, a1, a2, b1, b2)
  return b1 + (s-a1)*(b2-b1)/(a2-a1)
end

local z = GetValueNumber("z", max_distance)
local vz = -25
if not GetValueBool("initialized", false) then
  if not targetX then EntityKill(entity_id) return end
  SetValueBool("initialized", true)
  local dist_x = targetX - x
  local dist_y = targetY - y
  local scale = field_of_view / (field_of_view + z)
  SetValueNumber("dist_x", dist_x)
  SetValueNumber("dist_y", dist_y)
  SetValueNumber("origin_x", x - scale * dist_x)
  SetValueNumber("origin_y", y - scale * dist_y)
end
local origin_x = GetValueNumber("origin_x", x)
local origin_y = GetValueNumber("origin_y", y)
local dist_x = GetValueNumber("dist_x", 0)
local dist_y = GetValueNumber("dist_y", 0)
local scale = field_of_view / (field_of_view + z)
local visual_scale = map(scale, 0, 1, 0.1, 1)
EntitySetTransform(entity_id, origin_x + dist_x * scale, origin_y + dist_y * scale, rot, visual_scale, visual_scale)
z = z + vz
SetValueNumber("z", z)
if z <= 0 then
  shoot_projectile(entity_id, "data/entities/projectiles/flesh_stalker_explosion.xml", origin_x + dist_x, origin_y + dist_y, 0, 0, false)
  EntityKill(entity_id)
end