local nxml = dofile_once("mods/flesh_biome/lib/nxml.lua")

function replace_value(path, input, output, print_contents)
	local content = ModTextFileGetContent(path)
	content = content:gsub(input, output)
	ModTextFileSetContent(path, content)
	if print_contents == true then
		print(content)
	end
end

replace_value("data/scripts/biomes/rainforest.lua", 
[[6670]], 
[[7724]]
)

replace_value("data/scripts/biomes/rainforest.lua", 
[[8000]], 
[[9024]]
)

replace_value("data/scripts/biomes/summon_portal_util.lua", 
[[6700]], 
[[7724]]
)

replace_value("data/scripts/biomes/summon_portal_util.lua", 
[[8000]], 
[[9024]]
)

replace_value("data/biome/_pixel_scenes.xml", 
[[%s*%<PixelScene%s*DEBUG%_RELOAD%_ME%=%"0%"%s*background%_filename%=%"data%/biome%_impl%/snowcastle%/forge_background%.png%"%s*clean%_area%_before%=%"0%"%s*colors%_filename%=%"data%/biome%_impl%/snowcastle%/forge%_visual%.png%"%s*material%_filename%=%"data%/biome%_impl%/snowcastle%/forge%.png%"%s*pos%_x%=%"1464%"%s*pos%_y%=%"5976%"%s*skip%_biome%_checks%=%"1%"%s*skip%_edge%_textures%=%"0%"%s*>]], 
[[		<PixelScene DEBUG_RELOAD_ME="0" background_filename="data/biome_impl/snowcastle/forge_background.png" clean_area_before="0" colors_filename="data/biome_impl/snowcastle/forge_visual.png" material_filename="data/biome_impl/snowcastle/forge.png" pos_x="1454" pos_y="5464" skip_biome_checks="1" skip_edge_textures="0" >]]
)

replace_value("data/biome/_pixel_scenes.xml", 
[[%s*%<PixelScene%s*DEBUG%_RELOAD%_ME%=%"0%"%s*background%_filename%=%"data%/biome%_impl%/temple%/altar%_snowcastle%_capsule%_background%.png%"%s*clean%_area%_before%=%"0%"%s*colors%_filename%=%"%"%s*material%_filename%=%"data%/biome%_impl%/temple%/altar%_snowcastle%_capsule%.png%"%s*pos%_x%=%"143%"%s*pos%_y%=%"5112%"%s*skip%_biome%_checks%=%"1%"%s*skip%_edge%_textures%=%"0%"%s*>]], 
[[		<PixelScene DEBUG_RELOAD_ME="0" background_filename="data/biome_impl/temple/altar_snowcastle_capsule_background.png" clean_area_before="0" colors_filename="" material_filename="data/biome_impl/temple/altar_snowcastle_capsule.png" pos_x="143" pos_y="4600" skip_biome_checks="1" skip_edge_textures="0" >]]
)

replace_value("data/biome/_pixel_scenes.xml", 
[[%s*%<PixelScene%s*DEBUG%_RELOAD%_ME%=%"0%"%s*background%_filename%=%"%"%s*clean%_area%_before%=%"0%"%s*colors%_filename%=%"%"%s*material%_filename%=%"data%/biome%_impl%/temple%/altar%_vault%_capsule%.png%"%s*pos%_x%=%"143%"%s*pos%_y%=%"8704%"%s*skip%_biome%_checks%=%"1%"%s*skip%_edge%_textures%=%"0%"%s*>]], 
[[		<PixelScene DEBUG_RELOAD_ME="0" background_filename="" clean_area_before="0" colors_filename="" material_filename="data/biome_impl/temple/altar_vault_capsule.png" pos_x="143" pos_y="9728" skip_biome_checks="1" skip_edge_textures="0" >]]
)

replace_value("data/biome/_pixel_scenes.xml", 
[[%s*%<PixelScene%s*DEBUG%_RELOAD%_ME%=%"0%"%s*background%_filename%=%"%"%s*clean%_area%_before%=%"0%"%s*colors%_filename%=%"data%/biome%_impl%/eyespot%_visual%.png%"%s*material%_filename%=%"data%/biome%_impl%/eyespot%.png%"%s*pos%_x%=%"-1360%"%s*pos%_y%=%"9904%"%s*skip%_biome%_checks%=%"1%"%s*skip%_edge%_textures%=%"0%"%s*>]], 
[[		<PixelScene DEBUG_RELOAD_ME="0" background_filename="" clean_area_before="0" colors_filename="data/biome_impl/eyespot_visual.png" material_filename="data/biome_impl/eyespot.png" pos_x="-1360" pos_y="10928" skip_biome_checks="1" skip_edge_textures="0" >]]
)

--Appending custom biomes

local BIOMES = {
  {
    biome_filename="mods/flesh_biome/files/biome/flesh_biome.xml",
    height_index="0",
    color="ffee0897",
  },
  {
    biome_filename="mods/flesh_biome/files/biome/flesh_boss.xml",
    height_index="0",
    color="ff990862",
  },
  {
    biome_filename="mods/flesh_biome/files/biome/flesh_boss_mouth.xml",
    height_index="0",
    color="ffdd41a2",
  },
  {
    biome_filename="mods/flesh_biome/files/biome/solid_wall.xml",
    height_index="0",
    color="ff660742",
  },
  {
    biome_filename="mods/flesh_biome/files/biome/temple_altar_right_flesh.xml",
    height_index="0",
    color="ffc74ecb",
  }
}

function append_custom_biomes()
  local biome_data = ModTextFileGetContent("data/biome/_biomes_all.xml")
  local biomes_xml = nxml.parse(biome_data)

  for i, biome in ipairs(BIOMES) do
    biomes_xml:add_child(nxml.new_element("Biome", biome))
  end

  local biome_data_patched = nxml.tostring(biomes_xml)
  ModTextFileSetContent("data/biome/_biomes_all.xml", biome_data_patched)
end

append_custom_biomes()

-- local biome_utils = dofile("mods/flesh_biome/lib/biome_utils.lua")("flesh_biome")

--Add Biomes to _biomes_all.xml
-- biome_utils.add_biomes(
	-- { "mods/flesh_biome/files/biome/flesh_biome.xml", 0, "ffee0897" },
	-- { "mods/flesh_biome/files/biome/flesh_boss.xml", 0, "ff990862" },
	-- { "mods/flesh_biome/files/biome/flesh_boss_mouth.xml", 0, "ffdd41a2" },
	-- { "mods/flesh_biome/files/biome/solid_wall.xml", 0, "ff660742" },
	-- { "mods/flesh_biome/files/biome/temple_altar_right_flesh.xml", 0, "ffc74ecb" }
-- )

--Append Materials
ModMaterialsFileAdd("mods/flesh_biome/files/materials/materials.xml")

-- ModLuaFileAppend("mods/nightmare/files/biome_map.lua", "data/scripts/biomes/biome_map_armory_biomes.lua")
-- ModLuaFileAppend("data/scripts/newgame_plus.lua", "data/scripts/biomes/ngplus_biomes.lua")

--Addition of custom translations
local content = ModTextFileGetContent("data/translations/common.csv")
ModTextFileSetContent("data/translations/common.csv", content .. [[
flesh_biome,Oog's Bowels,,,,,,,,,,,,,
oog,Oog's Eyes,,,,,,,,,,,,,
flesh_boss,Oog's Eye,,,,,,,,,,,,,
flesh_boss_mouth,Oog's Mouth,,,,,,,,,,,,,
flesh_boss_tongue,Oog's Mouth,,,,,,,,,,,,,
flesh_boss_heart,Oog's Heart,,,,,,,,,,,,,
]])

--Addition of staining textures to enemy sprites:
-- ModDevGenerateSpriteUVsForDirectory( "mods/flesh_biome/data/enemies_gfx/" )

if ModIsEnabled("raksa") then
  ModLuaFileAppend( "mods/raksa/files/scripts/lists/entity_categories.lua", "mods/flesh_biome/files/conjurer_mod/conjurer_list.lua" )
end

ModLuaFileAppend( "data/scripts/biomes/snowcastle.lua", "mods/flesh_biome/files/append/snowcastle.lua" )
ModLuaFileAppend( "data/scripts/biomes/vault.lua", "mods/flesh_biome/files/append/vault.lua" )

--fixing portals
local content2 = ModTextFileGetContent("data/scripts/buildings/teleport_hourglass_return.lua")
content2 = content2:gsub("5223", "4711")
ModTextFileSetContent("data/scripts/buildings/teleport_hourglass_return.lua", content2)

replace_value("data/entities/buildings/teleport_hourglass.xml", 
[[5420]], 
[[4396]]
)


if ModIsEnabled("VolcanoBiome") then
	content2 = ModTextFileGetContent("mods/VolcanoBiome/files/scripts/temple_altar_left_append.lua")
	content2 = content2:gsub("8450", "7426")
	ModTextFileSetContent("mods/VolcanoBiome/files/scripts/temple_altar_left_append.lua", content2)
end

-- if ModIsEnabled("Apotheosis") then
	-- content2 = ModTextFileGetContent("mods/VolcanoBiome/files/scripts/temple_altar_left_append.lua")
	-- content2 = content2:gsub("8450", "7426")
	-- ModTextFileSetContent("mods/VolcanoBiome/files/scripts/temple_altar_left_append.lua", content2)
-- end

-- ModLuaFileAppend( "data/scripts/biome_map.lua", "mods/flesh_biome/files/append/biome_map_append.lua" )
-- if ModIsEnabled("Apotheosis") then
	-- ModLuaFileAppend( "mods/Apotheosis/files/scripts/biomes/biome_map.lua", "mods/flesh_biome/files/append/biome_map_append.lua" )
-- end

-- if ModIsEnabled("VolcanoBiome") then
	-- ModLuaFileAppend( "mods/VolcanoBiome/files/scripts/map_loader.lua", "mods/flesh_biome/files/append/biome_map_append.lua" )
-- end
function OnMagicNumbersAndWorldSeedInitialized()
	local map_string = MagicNumbersGetValue( "BIOME_MAP" )
	i, j = string.find(map_string, ".lua")
	
	if i > 0 then
		ModLuaFileAppend( map_string, "mods/flesh_biome/files/append/biome_map_append.lua" )
	end
end

-- function overlayNonTransparentPixels(source_path, target_path)
	-- local sourceId, sourceWidth, sourceHeight = ModImageMakeEditable(source_path, 0, 0)
	-- local targetId, targetWidth, targetHeight = ModImageMakeEditable(target_path, 0, 0)
	-- if sourceId ~= 0 and targetId ~= 0 then
		-- local width = math.min(sourceWidth, targetWidth)
		-- local height = math.min(sourceHeight, targetHeight)
		-- for y = 0, height - 1 do
			-- for x = 0, width - 1 do
				-- local sourceColor = ModImageGetPixel(sourceId, x, y)
				-- local alpha = bit.rshift(bit.band(sourceColor, 0xFF000000), 24) -- Extract alpha channel
				-- if alpha > 0 then
                    -- -- Get biome type from color (assuming color represents biome)
                    -- local biomeType = BiomeMapConvertPixelFromUintToInt(sourceColor)
                    -- -- Set biome type at corresponding position in target biome map
                    -- BiomeMapSetPixel(x, y, biomeType)
				-- end
			-- end
		-- end
	-- end
-- end

-- if ModIsEnabled("Apotheosis") then
	-- overlayNonTransparentPixels("mods/flesh_biome/files/biome_impl/apotheosis_biome_map_overlay.png", "mods/Apotheosis/files/biome_impl/biome_map.png")
-- else
	-- overlayNonTransparentPixels("mods/flesh_biome/files/biome_impl/biome_map_overlay.png", "data/biome_impl/biome_map.png")
-- end